
--
-- loadCompression
--
--  Author:  mjk
--  Datum: 26.08.2016
--  Version: 1.0.0
--
-- license: GNU General Public License  
-- 

-- Manual:
-- 1. put this in your vehicle.xml   -> <loadCompression low="49000" medium="55000" high="64000" />

-- 2. Add these lines to your modDesc.xml -> 
--	<l10n>
--      <text name="LOADCOMPRESSION_CHANGECOMPRESSION">			<de>Kompression: </de>	<en>Compression: </en>		</text>
--		<text name="LOADCOMPRESSION_CHANGECOMPRESSION_OFF">		<de>aus</de>			<en>off</en>				</text>
--		<text name="LOADCOMPRESSION_CHANGECOMPRESSION_LOW">		<de>wenig</de>			<en>low</en>				</text>
--		<text name="LOADCOMPRESSION_CHANGECOMPRESSION_MEDIUM">	<de>mittel</de>			<en>middle</en>				</text>
--		<text name="LOADCOMPRESSION_CHANGECOMPRESSION_HIGH">	<de>hoch</de>			<en>high</en>				</text>	
--  </l10n>
	
--	<inputBindings>
--		<input name="LOADCOMPRESSION_CHANGECOMPRESSION" 	category="VEHICLE" key1="KEY_z" button="" />
--  </inputBindings>

--  <specializations>
--		<specialization name="loadcompression"	className="loadCompression" filename="loadCompression.lua"/>		
--	</specializations>

-- 3. Add this in your modDesc at your vehicle specializations -> <specialization name="loadcompression" />


loadCompression = {};
local isDebug = false;
local firstLoad = true;
local limitToChange = 50;--ab dem % Wert, kann man die kompression nicht mehr ändern

function loadCompression:prerequisitesPresent(specializations)
	--return SpecializationUtil.hasSpecialization(Fillable, specializations) and SpecializationUtil.hasSpecialization(ForageWagon, specializations);
	return true;
end;

function loadCompression:load(xmlFile)
	self.selectedCompression = 0;
	self.lastFillLevel = 0;
	self.loadInPercent = 0;
	self.onePercent = 0;
	self.isMax = false;
	self.isLoading = false;
	self.compressions = {};

	if self.capacity > 0 then		
		self.compressions[0] = self.capacity;
		self.compressions[1] = getXMLFloat(xmlFile, "vehicle.loadCompression#low") or self.capacity;
		self.compressions[2] = getXMLFloat(xmlFile, "vehicle.loadCompression#medium") or self.capacity;
		self.compressions[3] = getXMLFloat(xmlFile, "vehicle.loadCompression#high") or self.capacity;
	end;
	
	-- for i = 0, 3 do
		-- loadCompression:printMessage("Capacities [" ..i.. "]: " ..self.compressions[i]);	
	-- end;

	self.setFillLevel = Utils.appendedFunction(self.setFillLevel, loadCompression.SetFillLevel);	
	self.onePercent = self.compressions[0] / 100;
	
end;

function loadCompression:SetFillLevel(fillLevel, fillType, force)
	--loadCompression:printMessage("loadCompression:SetFillLevel start");
	self.maxFL = 0;

	--SetMaxFillLevel
	self.maxFL = self.compressions[self.selectedCompression];
	self.loadInPercent =  math.floor(((self.fillLevel / self.capacity) * 100) + .1);
	
	--loadCompression:printMessage("loadCompression:SetFillLevel end");
	if firstLoad == true then
		firstLoad = false;
		return;
	end;
	
	if self.lastFillLevel < fillLevel then
		self.isLoading = true;
	else 
		self.isLoading = false;
	end;
	
	-- ignore Chaff
	if fillType == Fillable.FILLTYPE_CHAFF then
		return;
	end;
	
	if self.isLoading == true and self.loadInPercent >= 95 then		
		if (self.capacity + self.onePercent) <= self.maxFL then
			self.capacity = self.capacity + self.onePercent;
			loadCompression:printMessage("Load | Neue Fuellmenge: " ..self.capacity);
		elseif self.isMax == false then
			self.capacity = self.maxFL;
			self.isMax = true;
			loadCompression:printMessage("Load | Neue Fuellmenge: " ..self.capacity.. " (MAX)!");			
		end;
	elseif self.isLoading == false and self.loadInPercent < 95 then		
		if (self.capacity - self.onePercent) >= self.compressions[0] then
			self.capacity = self.capacity - self.onePercent;
			loadCompression:printMessage(" Unload | Neue Fuellmenge: " ..self.capacity);
		else
			if self.capacity > self.compressions[0]  then
				self.capacity = self.compressions[0];
				loadCompression:printMessage(" Unload | Neue Fuellmenge: " ..self.capacity.. " (MIN)!");
			end;
		end;		
		self.isMax = false;
	end;
	
end;

function loadCompression:update(dt) 

	--ChangeCompression
	if InputBinding.hasEvent(InputBinding.LOADCOMPRESSION_CHANGECOMPRESSION)then
		
		if self.loadInPercent < limitToChange then 
			if self.selectedCompression < 3 then
				self.selectedCompression = self.selectedCompression + 1;
			else
				self.selectedCompression = 0;
			end;
		end;
	end;
end;

function loadCompression:loadFromAttributesAndNodes(xmlFile, key, resetVehicles)
	if not resetVehicles then
		self.selectedCompression = Utils.getNoNil(getXMLInt(xmlFile, key..'#selectedCompression'), 0);
		self.lastFillLevel = Utils.getNoNil(getXMLInt(xmlFile, key..'#lastFillLevel'), 0);
	end;	
	
	loadCompression:printMessage(" LoadAttrbutes: selectesCompression: " ..self.selectedCompression);
	loadCompression:printMessage(" LoadAttrbutes: lastFillLevel: " ..self.lastFillLevel);
	
	return BaseMission.VEHICLE_LOAD_OK;
end;

function loadCompression:getSaveAttributesAndNodes(nodeIdent)
	local attributes = "";
	
	attributes = attributes ..'selectedCompression="'..tostring(self.selectedCompression)..'"';
	attributes = attributes ..' lastFillLevel="'..tostring(self.lastFillLevel)..'"';
	
	return attributes;
end;

function loadCompression:draw()
	
	if self:getIsActiveForInput() and self.loadInPercent < limitToChange then	
		if self.selectedCompression == 0 then
			g_currentMission:addHelpButtonText(g_i18n:getText("LOADCOMPRESSION_CHANGECOMPRESSION") .. g_i18n:getText("LOADCOMPRESSION_CHANGECOMPRESSION_OFF") .. 	" (" ..self.compressions[self.selectedCompression].. ")"	, InputBinding.LOADCOMPRESSION_CHANGECOMPRESSION);
		elseif self.selectedCompression == 1 then
			g_currentMission:addHelpButtonText(g_i18n:getText("LOADCOMPRESSION_CHANGECOMPRESSION") .. g_i18n:getText("LOADCOMPRESSION_CHANGECOMPRESSION_LOW") .. 	" (" ..self.compressions[self.selectedCompression].. ")"	, InputBinding.LOADCOMPRESSION_CHANGECOMPRESSION);
		elseif self.selectedCompression == 2 then
			g_currentMission:addHelpButtonText(g_i18n:getText("LOADCOMPRESSION_CHANGECOMPRESSION") .. g_i18n:getText("LOADCOMPRESSION_CHANGECOMPRESSION_MEDIUM") .. " (" ..self.compressions[self.selectedCompression].. ")"	, InputBinding.LOADCOMPRESSION_CHANGECOMPRESSION);
		elseif self.selectedCompression == 3 then
			g_currentMission:addHelpButtonText(g_i18n:getText("LOADCOMPRESSION_CHANGECOMPRESSION") .. g_i18n:getText("LOADCOMPRESSION_CHANGECOMPRESSION_HIGH") .. 	" (" ..self.compressions[self.selectedCompression].. ")"	, InputBinding.LOADCOMPRESSION_CHANGECOMPRESSION);
		end;		
	else
		g_currentMission:addHelpButtonText(g_i18n:getText("LOADCOMPRESSION_CHANGECOMPRESSION") .. g_i18n:getText("LOADCOMPRESSION_CHANGECOMPRESSION_OFF") .. 	" (" ..self.compressions[self.selectedCompression].. ") fix!",  InputBinding.LOADCOMPRESSION_CHANGECOMPRESSION);
	end;
end;

function loadCompression:printMessage(message)
	if isDebug == true then
		print("LOADCOMRESSION MESSAGE: " ..tostring(message));
	end;
end;

function loadCompression:delete() end;
function loadCompression:mouseEvent(posX, posY, isDown, isUp, button) end;
function loadCompression:keyEvent(unicode, sym, modifier, isDown) end;
function loadCompression:updateTick(dt) end;
